CREATE OR replace PROCEDURE etapausaset( kisak IN INTEGER,
					 tapausk IN INTEGER DEFAULT NULL,
					 ttyyppi IN INTEGER,
					 taika IN NUMBER DEFAULT NULL,
					 tkuski IN INTEGER,
					 nappi IN VARCHAR2)
IS
   uusikoodi INTEGER;
   uusikuski INTEGER;
BEGIN
   --Voisi parannella!
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 

   IF tapausk IS NULL THEN
      SELECT max(koodi)+1 INTO uusikoodi FROM tapaus WHERE kilpailu=kisak;
      IF uusikoodi IS NULL THEN
	 uusikoodi:=0;
      END IF;
      
   ELSE
      uusikoodi:=tapausk;
   END IF;
   
   IF tkuski>=0 THEN
      uusikuski:=tkuski;
   ELSE
      uusikuski:=NULL;
   END IF;
   
   IF taika<0 AND (nappi = 'Lis' OR nappi='Pivit') THEN
      raise_application_error(-20107,'Negatiivinen tapahtuma-aika');
   END IF;
   
   htp.p(uusikoodi);
   IF nappi = 'Lis' THEN 
      INSERT INTO tapaus VALUES(uusikoodi,kisak,taika,ttyyppi,uusikuski);
   ELSIF nappi='Pivit' THEN 
      UPDATE tapaus SET kuljettaja=uusikuski, tyyppi=ttyyppi, aika=taika
	WHERE koodi=uusikoodi AND kilpailu=kisak;
   ELSIF nappi='Poista' THEN
      DELETE tapaus WHERE koodi=uusikoodi AND kilpailu=kisak;
   ELSE
      htp.p('Nyt ei kunnian kukko laula!');
   END IF;
   
   kilpailusyott(kisak);
EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri etapausaset suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON etapausaset TO www_user;
EXIT

