CREATE OR replace PROCEDURE etapaussyott(etapaus IN INTEGER DEFAULT NULL,
					kisak IN INTEGER)
IS
   vanhat tapaus%ROWTYPE;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   
   iht2.js_checksonly;
   
   
   IF etapaus IS NOT NULL THEN 
      SELECT * INTO vanhat FROM tapaus WHERE koodi=etapaus AND kilpailu=kisak;
   END IF;
   
   otsikko('Erikoistapahtuma',true);
   
   htp.formopen('ops$kpalin.etapausaset');
   htp.formhidden('kisak',kisak);
   IF etapaus IS NOT NULL THEN
      htp.formhidden('tapausk',etapaus);
   END IF;
     
   htp.tableopen(NULL,'center');
   htp.tableheader('Tyyppi');
   htp.tableheader('Kuljettaja');
   htp.tableheader('Aika');
   htp.tablerowopen;
   htp.p('<td>');
   taptyyppiselect('ttyyppi',NULL,vanhat.tyyppi);
   htp.p('</td><td>');
   kuskiselect('tkuski','Ei liittyv',vanhat.kuljettaja,kisak);
   htp.p('</td><td>');
   htp.formtext('taika',20,20,vanhat.aika,'onBlur="numcheck(this)"');
   htp.tablerowclose;
   htp.tableclose;
   
   
   htp.tableopen(NULL,'center');
   htp.tablerowopen;
   htp.p('<td colspan=50 >');
   IF vanhat.tyyppi IS NOT NULL THEN
      htp.formsubmit('nappi','Pivit');
      htp.p('<td colspan=50>');
      htp.formsubmit('nappi','Poista');
   ELSE
      htp.formsubmit('nappi','Lis');
   END IF;
   
   htp.p('<td colspan=50>');
   htp.formreset('Peruuta', 'onClick=javascript:history.go(-1)');
   htp.tablerowclose;
   htp.tableclose;
   htp.formclose;

   
   htp.anchor('ops$kpalin.taptyypsyott','Lis');
   htp.p(' uusi tapahtumatyyppi.');
   paate ;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri etapaussyott suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON etapaussyott TO www_user;
EXIT
