CREATE OR replace PROCEDURE kalenteri(skoodi IN INTEGER)
IS
   cursor kisat IS SELECT  k.koodi,aajo,kilpailu,sarja,nimi,sijainti pituus,ennatys,vvuosi,sijainti 
     FROM rata r, kilpailu k 
     WHERE k.sarja=skoodi AND r.koodi=k.rata
     ORDER BY kilpailu desc;
   kilpa kisat%ROWTYPE;
   TYPE taustavari IS TABLE OF VARCHAR2(20) INDEX BY binary_integer;
   taustat taustavari;
   counter INTEGER;
BEGIN
   otsikko('Kilpailukalenteri');
   
   htp.tableopen(NULL,NULL,NULL,NULL,'width=90% border=4');
   htp.tabledata('<a href=ops$kpalin.uutiset>Uutiset</a>','center');
   htp.tabledata('<a href=ops$kpalin.sarjasivu?skoodi='||skoodi||'>Sarja</a>','center');
   htp.tabledata('<a href=ops$kpalin.tallit>Tallit</a>','center');
   htp.tabledata('<a href=ops$kpalin.kuljettajat>Kuljettajat</a>','center');
   htp.tableclose;
   htp.line;
   
   htp.p('Tll kaudella ajetaan seuraavat kilpailut:');
   htp.tableopen(NULL,'center');
   taustat(1):='bgcolor=#99cccc';
   taustat(2):=NULL;
   counter:=1;
   
   FOR kilpa IN kisat LOOP
      htp.tablerowopen;
      htp.tabledata('<a href=ops$kpalin.kilpailusivu?kkoodi='||kilpa.koodi||'>'||
	kilpa.sijainti||', '||kilpa.nimi||'</a>',NULL,NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      htp.tabledata(to_char(kilpa.kilpailu,'DD.MM.YYYY'),NULL,NULL,NULL,NULL,NULL,taustat(MOD(counter,2)+1));
      counter:=counter+1;
      htp.tablerowclose;
   END LOOP;
   htp.tableclose;
   paate;
   
EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri kalenteri suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON kalenteri TO www_user;
EXIT
