CREATE OR replace PROCEDURE kaudetselect(snimi IN VARCHAR2 ,
				       tyhja IN VARCHAR2 DEFAULT null,
				       valittu IN INTEGER DEFAULT -1)  IS
   cursor sarjat IS SELECT * FROM sarja ;
   kausi sarjat%ROWTYPE ;
BEGIN
   
   htp.formselectopen(snimi);
   IF length(tyhja)>0 THEN
      IF valittu = -1 THEN 
	 htp.formselectoption(tyhja,'selected','value=-1');
      else
	 htp.formselectoption(tyhja,NULL ,'value=-1');
      END IF;
   END IF;
   
   FOR kausi IN sarjat LOOP
      IF kausi.koodi = valittu THEN 
	 htp.formselectoption(kausi.vuosi,'selected',
			     'value='||kausi.koodi);
      ELSE
	 htp.formselectoption(kausi.vuosi,NULL,
			     'value='||kausi.koodi);
      END IF;
   END LOOP;
   
   htp.formselectclose;
   
   EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri kaudetselect suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON kaudetselect TO www_user;
EXIT
  
