CREATE OR replace PROCEDURE kotiratapoista(aikakoodi IN INTEGER,
					   krnappi IN VARCHAR2) 
IS
   tkoodi INTEGER;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF;
   
   otsikko('Kotiratamerkint poistettu',true);
   
   SELECT tokakoodi INTO tkoodi FROM aika WHERE kerta=aikakoodi;
   
   htp.p('Merkint tallin kotiradasta on nyt poistettu. Voit palata, joko ');
   htp.anchor('ops$kpalin.tallimuokk','tallilistaan');
   htp.p('tai ksiteltvn ');
   htp.anchor('ops$kpalin.tallisyott?tkoodi='||tkoodi,'talliin.');
   
   -- vr paikka mutta so..
   DELETE aika WHERE kerta=aikakoodi;
   
   paate ;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri kotiratapoista suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON kotiratapoista TO www_user;
EXIT
  
