CREATE OR replace PROCEDURE kuljpoista (kkoodi IN INTEGER,
				       nappula IN VARCHAR2 DEFAULT NULL ) IS
   poistok kuljettaja%ROWTYPE;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   
   SELECT * INTO poistok FROM kuljettaja WHERE koodi=kkoodi;
   DELETE kuljettaja WHERE koodi=kkoodi;
   
   otsikko('Kuljettaja poistettu',true);
   htp.p(poistok.enimi||' '||poistok.snimi||' on poistettu tietokannasta. ');
   htp.p('Voit palata ');
   htp.anchor('ops$kpalin.kuljmuokk','muokkaamaan');
   htp.p(' kuljettajia.');
   paate ;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri kuljpoista suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON kuljpoista TO www_user;
EXIT
  
