CREATE OR replace PROCEDURE kuskiselect(snimi IN VARCHAR2 ,
				       tyhja IN VARCHAR2 DEFAULT null,
				       valittu IN INTEGER DEFAULT -1,
				       kkoodi IN INTEGER )  IS
   cursor kuljettajat IS SELECT k.koodi,k.enimi,k.snimi,k.saika,k.spaikka,
     k.kaika,k.kpaikka,k.kansalaisuus,k.kotipaikka,talli.nimi tnimi
     FROM kuljettaja k,talli,tallisarja,kilpailu kplu,aika
     WHERE kplu.koodi=kkoodi AND 
     tallisarja.sarjakoodi=kplu.sarja AND 
     tallisarja.tallikoodi=talli.koodi AND 
     aika.tyyppi=(SELECT tyyppi FROM aikasuhteet 
     WHERE ensimmainen='kuljettaja' AND toinen='talli') AND
     aika.alkamisaika<kplu.aajo AND 
     (aika.loppumisaika IS NULL OR aika.loppumisaika>kplu.kilpailu)
     AND aika.ekakoodi=k.koodi AND 
     aika.tokakoodi=talli.koodi
     ORDER BY tnimi,snimi;
   suhari kuljettajat%ROWTYPE ;
BEGIN
   
   htp.formselectopen(snimi);
   IF length(tyhja)>0 THEN
      IF valittu = -1 THEN 
	 htp.formselectoption(tyhja,'selected','value=-1');
      else
	 htp.formselectoption(tyhja,NULL ,'value=-1');
      END IF;
   END IF;
   
   FOR suhari IN kuljettajat LOOP
      IF suhari.koodi = valittu THEN 
	 htp.formselectoption(suhari.enimi||' '||suhari.snimi,'selected',
			     'value='||suhari.koodi);
      ELSE
	 htp.formselectoption(suhari.enimi||' '||suhari.snimi,NULL,
			     'value='||suhari.koodi);
      END IF;
   END LOOP;
   
   htp.formselectclose;
   
   EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri kuskiselect suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON kuskiselect TO www_user;
EXIT
  
