CREATE OR replace PROCEDURE moottoriaseta(aikakoodi IN INTEGER,
					   mnappi IN VARCHAR2,
					   mkoodi IN INTEGER,
					   malku IN VARCHAR2,
					   mloppu IN VARCHAR2 DEFAULT null)
IS
   taika aika%ROWTYPE;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF;
   
   
   SELECT * INTO taika FROM aika WHERE kerta=aikakoodi;
   
   
   IF mnappi = 'Poista' THEN
      DELETE aika WHERE kerta = taika.kerta;
      
      
      otsikko('Merkint poistettu',true);
      htp.p('Merkint tallin kyttmst moottorista on nyt poistettu.');
   ELSIF mnappi = 'Pivit' THEN
      UPDATE aika SET ekakoodi=mkoodi, 
	alkamisaika=to_date(malku,'DD.MM.YYYY'),
	loppumisaika=to_date(mloppu,'DD.MM.YYYY')
	WHERE kerta=aikakoodi;
      
      otsikko('Tiedot pivitetty',true);
      htp.p('Tiedot tallin moottorivalinnasta on nyt pivitetty.');
   END IF;
   
   
   htp.p(' Voit palata, joko ');
   htp.anchor('ops$kpalin.tallimuokk','tallilistaan');
   htp.p('tai ksiteltvn ');
   htp.anchor('ops$kpalin.tallisyott?tkoodi='||taika.tokakoodi,'talliin.');
    
   paate ;

EXCEPTION
   WHEN OTHERS THEN
     
     IF sqlcode = -1847 THEN
	otsikko('Virheellinen pivmr!');
	htp.p('Jokin antamasi pivmr oli vrn muotoinen. Pivmrt ');
	htp.p(' pit antaa muodossa '||to_char(sysdate,'DD.MM.YYYY')||'.');
     ELSIF sqlcode = -1858 THEN
	otsikko('Teksti numerokentss!');
	htp.p('Jossain kentss, johon pit kirjoittaa luku, on muita kuin');
	htp.p(' numeroja.');
     ELSE 
	htp.p('<h3>Proseduuri moottoriaseta suoritus pttyi virheeseen:</h3>');
	htp.p('<font color=red>'|| sqlerrm || '</font>');
     END IF;
     
     htp.p('Muutoksia ei ole talletettu tietokantaan!');
     paate;
END;
/
show errors
  GRANT execute ON moottoriaseta TO www_user;
EXIT
  
