CREATE OR replace PROCEDURE moottorilis(mkoodi IN INTEGER DEFAULT -1)  IS
   cursor kmoottorit IS SELECT * FROM moottori;
   tmoot moottori%ROWTYPE;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   otsikko('Jrjestelmn tallennetut moottorit',true);
   
   iht2.js_checksonly;
   htp.ulistopen;
   FOR tmoot IN kmoottorit LOOP
      htp.listitem('<a href=ops$kpalin.moottorilis?mkoodi='||
	tmoot.koodi||'>'||tmoot.valmistaja||' '||
	tmoot.tyyppi||'</a> ('||to_char(tmoot.vuosimalli,'YYYY')||
	' '||tmoot.teho||'hv)');
   END LOOP;
   
   htp.ulistclose;
   
   htp.formopen('ops$kpalin.uusimoottori');
   htp.formhidden('mkoodi',mkoodi);
   
   htp.tableopen(NULL,'center');
   htp.tableheader('Valmistaja');
   htp.tableheader('Tyyppi');
   htp.tableheader('Vuosimalli');
   htp.tableheader('Teho');
   
   IF mkoodi>=0 THEN
      SELECT * INTO tmoot FROM moottori  WHERE koodi=mkoodi;
   END IF;
   
   htp.tablerowopen;
   htp.p('<td>');
   htp.formtext('mvalmist',32,128,tmoot.valmistaja);
   htp.p('</td><td>');
   htp.formtext('mtyyppi',32,64,tmoot.tyyppi);
   htp.p('</td><td>');
   htp.formtext('mvmalli',5,4,to_char(tmoot.vuosimalli,'YYYY'),'onBlur="numcheck(this)"');
   htp.p('</td><td>');
   htp.formtext('mteho',5,4,tmoot.teho,'onBlur="numcheck(this)"');
   htp.p('hv</td>');
   htp.tablerowclose;
   htp.tableclose;

   htp.tableopen(NULL,'center');
   htp.tablerowopen;
   htp.p('<td colspan=50 >');

   IF mkoodi >= 0 THEN
      htp.formsubmit('mnappi','Pivit');
      htp.p('<td colspan=50>');
      htp.formsubmit('mnappi','Poista');
   ELSE
      htp.formsubmit('mnappi','Lis');
   END IF;
   
   htp.p('<td colspan=50>');
   htp.formreset('Peruuta', 'onClick=javascript:history.go(-1)');
   htp.tablerowclose;
   htp.tableclose;
   htp.formclose;

   paate ;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri moottorilis suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON moottorilis TO www_user;
EXIT
  
