CREATE OR replace PROCEDURE otsikko (teksti IN VARCHAR2 , 
				     poisto IN BOOLEAN DEFAULT false) IS 
BEGIN
   htp.p('<!doctype html public "-//W3C//DTD HTML 3.2//FI">');
   htp.htmlopen ;
   htp.headopen ;
   htp.title(teksti);
   htp.headclose ;
   htp.bodyopen(NULL, 'bgcolor=white');
   htp.tableopen(NULL,NULL,NULL,NULL,'width=90%');
   htp.tablerowopen(NULL, 'top');
   htp.tabledata('Helsingin yliopisto, Tietojenksittelytieteen laitos<br>'||
     'Informaatiojrjestelmien harjoitusty');
   htp.p('<td align=right>');
   htp.anchor('javascript:history.go(-1)','<img src="http://www.helsinki.fi/hy/prev.gif" border=0 alt="Edellinen">');
   htp.anchor('javascript:history.go(1)','<img src="http://www.helsinki.fi/hy/next.gif" border=0 alt="Seuraava">');
   IF poisto THEN
      htp.anchor('ops$kpalin.logout','<img src="http://www.cs.helsinki.fi/~kpalin/infol/logout.gif" border=0 alt="Logout">');
   END IF ;
   htp.p('</td>');
   htp.tablerowclose ;
   htp.tablerowopen ;
   htp.tabledata(NULL,NULL,NULL,NULL,'colspan=2');
   htp.tableclose ;
   htp.line ;
   htp.header(2,teksti);
   --iht.header(teksti,NULL,NULL);
   
EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri otsikko suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON otsikko TO www_user;
EXIT
  
