CREATE OR replace PROCEDURE paasivu(tarkistaauth IN BOOLEAN DEFAULT true)  IS
   tsarja INTEGER;
BEGIN
   IF tarkistaauth AND NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   otsikko('Jrjestelmn yllpito',true);

   htp.p('Tervetuloa F1-tiedotusjrjestelmn yllpitotilaan. Seuraavasta');
   htp.p('valikosta pset eteenpin muokkaamaan systeemin tietosislt.');
   htp.ulistopen ;
   --htp.listitem('Kausi '||to_char(sysdate,'YYYY')||'.');
   --htp.listitem('Ksittele kausia ja kilpailuja.');
   htp.listitem('<a href=ops$kpalin.tallimuokk>Muokkaa talleja.</a>');
   htp.ulistopen;
   htp.listitem('<a href=ops$kpalin.rengaslis>Lis renkaita.</a>');
   htp.listitem('<a href=ops$kpalin.moottorilis>Lis mootoreita.</a>');
   htp.ulistclose;
   htp.listitem('<a href=ops$kpalin.kuljmuokk>Pvit kuljettajatietoja.</a>');
   htp.listitem('<a href=ops$kpalin.radatmuokk>Muokkaa ratatietoja.</a>');
   htp.listitem('<a href=ops$kpalin.logout>Poistu jrjestelmst.</a>');
   htp.ulistclose ;
   
   -- Hieno kysely menossa olevan sarjan valinnaksi.
   BEGIN 
      SELECT k.sarja INTO tsarja FROM kilpailu k 
	WHERE ABS(sysdate-k.kilpailu)= (SELECT min(ABS(sysdate-a.kilpailu)) FROM
	kilpailu a );
   EXCEPTION
      WHEN no_data_found THEN
	tsarja:=NULL;
   END;
   
   
   htp.formopen('ops$kpalin.valitsekaudet');
   htp.p('Ksitelln kautta: ');
   kaudetselect('tkausi','Uusi kausi',tsarja);
   htp.formsubmit('valitse','Ksittele');
   htp.formclose;
   
   htp.p('Ole ystvllinen ja poistu jrjestelmst hallitusti, ');
   htp.p('lopettaessasi sen kytn.');
   paate ;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri paasivu suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON paasivu TO www_user;
EXIT
  
