CREATE OR replace PROCEDURE rataaseta 
  (rnimi IN VARCHAR2, 
  rsijainti IN VARCHAR2, 
  rpituus IN NUMBER, 
  rennatys IN NUMBER,
  rvalvuosi IN INTEGER, 
  rkuva IN VARCHAR2,
  rnappi IN VARCHAR2,
  rkoodi IN INTEGER)  
IS
   uusikoodi INTEGER ;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   
   IF rnappi = 'Pivit' THEN
      UPDATE rata
	SET nimi = rnimi, sijainti = rsijainti, pituus = rpituus,
	ennatys = rennatys, vvuosi = rvalvuosi, kuvaurl = rkuva
	WHERE rata.koodi=rkoodi;
      otsikko('Ratatiedot pivitetty!',true);
      htp.p('Uudet rataa koskevat tiedot on viety tietokantaan. Nyt voit ');
      htp.anchor('ops$kpalin.radatmuokk','palata');
      htp.p(' ksittelemn muita ratoja.');
   ELSIF rnappi = 'Poista' THEN 
      otsikko('Poista rata?',true);
      htp.p('Haluatko todella poistaa '|| rnimi||' radan tietokannasta?');
      htp.p('Poisto on lopullinen eik onnistu, jos rataan on viitteit ');
      htp.p('muualta jrjestelmst. Paina kyll jos ');
      htp.em('haluat');
      htp.p('poistaa radan.');
      htp.para;
      htp.formopen('ops$kpalin.ratapoista');
      htp.formhidden('rkoodi',rkoodi);
      
      htp.tableopen;
      htp.tablerowopen;
      htp.p('<td colspan=50>');
      --htp.p('<INPUT TYPE="submit" VALUE="Kyll">');

      htp.formsubmit('nappula','Kyll');
      htp.p('<td colspan=50>');
      htp.formreset('Ei','onClick=javascript:history.go(-1)');
      htp.tablerowclose;
      htp.tableclose;
      htp.formclose;
      --DELETE FROM rata WHERE rata.koodi=rkoodi;
   ELSIF rnappi = 'Lis' THEN

      SELECT max(rata.koodi) INTO uusikoodi FROM rata;
      
      IF uusikoodi  >= 0 THEN
	 uusikoodi := uusikoodi+1; --Tysin turhaa mutta NULL on outolintu
      ELSE
	 uusikoodi :=0;
      END IF;

     
      INSERT INTO rata VALUES (uusikoodi, rnimi,rsijainti,rpituus,rennatys,
	rvalvuosi, rkuva);
      otsikko('Rata listty!');
      htp.p('Uusi rata on nyt listty tietokantaan ja voit ');
      htp.anchor('ops$kpalin.radatmuokk','palata');
      htp.p(' muokkaamaan muita ratoja.');
   ELSE
      htp.p('Virhe rataaseta-proseduurissa. Ole hyv ja ota yhteytt ');
      htp.mailto('kimmo.palin@helsinki.fi','yllpitoon.');
   END IF;
     

   paate ;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri rataaseta suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON rataaseta TO www_user;
EXIT
  
