CREATE OR replace PROCEDURE ratapoista ( rkoodi IN INTEGER,
				       nappula IN VARCHAR2 DEFAULT NULL ) IS
   poistor rata%ROWTYPE;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   
   SELECT * INTO poistor FROM rata WHERE koodi=rkoodi;
   DELETE rata WHERE koodi=rkoodi;
   
   otsikko('Rata poistettu',true);
   htp.p(poistor.nimi||'-rata on poistettu. Voit palata ');
   htp.anchor('ops$kpalin.radatmuokk','muokkaamaan');
   htp.p(' ratoja.');
   paate ;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri ratapoista suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON ratapoista TO www_user;
EXIT
  
