CREATE OR replace PROCEDURE ratasivu(rkoodi IN INTEGER)
IS
   tamar rata%ROWTYPE;
   tsarja INTEGER;
BEGIN
   SELECT * INTO tamar FROM rata WHERE koodi=rkoodi;
   
      BEGIN 
      SELECT k.sarja INTO tsarja FROM kilpailu k 
	WHERE ABS(sysdate-k.kilpailu)= (SELECT min(ABS(sysdate-a.kilpailu)) FROM
	kilpailu a );
   EXCEPTION
      WHEN no_data_found THEN
	tsarja:=NULL;
   END;

   otsikko(tamar.nimi||'-rata');
   
   htp.tableopen(NULL,NULL,NULL,NULL,'width=90% border=4');
   htp.tabledata('<a href=ops$kpalin.kalenteri?skoodi='||tsarja||'>Kalenteri</a>','center');
   htp.tabledata('<a href=ops$kpalin.sarjasivu?skoodi='||tsarja||'>Sarja</a>','center');
   htp.tabledata('<a href=ops$kpalin.tallit>Tallit</a>','center');
   htp.tabledata('<a href=ops$kpalin.kuljettajat>Kuljettajat</a>','center');
   htp.tableclose;
   htp.line;
   
   htp.tableopen;
   htp.tablerowopen;
   htp.tabledata('<img src='||tamar.kuvaurl||'>');
   htp.p('<td>');
   htp.tableopen;
   htp.tablerowopen;
   htp.tabledata('Nimi:');
   htp.tabledata(tamar.nimi);
   htp.tablerowclose;
   htp.tablerowopen;
   htp.tabledata('Sijainti:');
   htp.tabledata(tamar.sijainti);
   htp.tablerowclose;
   htp.tablerowopen;
   htp.tabledata('Pituus:');
   htp.tabledata(tamar.pituus||' km');
   htp.tablerowclose;
   htp.tablerowopen;
   htp.tabledata('Kierrosenntys:');
   htp.tabledata(aikamuoto(tamar.ennatys));
   htp.tablerowclose;
   htp.tablerowopen;
   htp.tabledata('Valmistumisvuosi:');
   htp.tabledata(tamar.vvuosi);
   htp.tableclose;
   htp.tableclose;
   paate;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri ratasivu suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON ratasivu TO www_user;
EXIT
