CREATE OR replace PROCEDURE rengaslis(rkoodi IN INTEGER DEFAULT -1)  IS
   cursor krenkaat IS SELECT * FROM renkaat;
   rengas renkaat%ROWTYPE;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   otsikko('Jrjestelmn tallennetut renkaat',true);
   
   iht2.js_checksonly;
   htp.ulistopen;
   FOR rengas IN krenkaat LOOP
      htp.listitem('<a href=ops$kpalin.rengaslis?rkoodi='||rengas.koodi||'>'||
	rengas.valmistaja||': '||rengas.tyyppi||'</a>');
   END LOOP;
   
   htp.ulistclose;
   
   htp.formopen('ops$kpalin.uusirengas');
   htp.formhidden('rkoodi',rkoodi);
   
   htp.tableopen(NULL,'center');
   htp.tableheader('Valmistaja');
   htp.tableheader('Tyyppi');
   
   IF rkoodi>=0 THEN
      SELECT * INTO rengas FROM renkaat  WHERE koodi=rkoodi;
   END IF;
   
   htp.tablerowopen;
   htp.p('<td>');
   htp.formtext('rvalmist',32,64,rengas.valmistaja);
   htp.p('</td><td>');
   htp.formtext('rtyyppi',32,64,rengas.tyyppi);
   htp.p('</td>');
   htp.tablerowclose;
   htp.tableclose;

   htp.tableopen(NULL,'center');
   htp.tablerowopen;
   htp.p('<td colspan=50 >');

   IF rkoodi >= 0 THEN
      htp.formsubmit('rnappi','Pivit');
      htp.p('<td colspan=50>');
      htp.formsubmit('rnappi','Poista');
   ELSE
      htp.formsubmit('rnappi','Lis');
   END IF;
   
   htp.p('<td colspan=50>');
   htp.formreset('Peruuta', 'onClick=javascript:history.go(-1)');
   htp.tablerowclose;
   htp.tableclose;
   htp.formclose;

   paate ;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri rengaslis suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON rengaslis TO www_user;
EXIT
  
