CREATE OR replace PROCEDURE rengasselect(snimi IN VARCHAR2 ,
				       tyhja IN VARCHAR2 DEFAULT null,
				       valittu IN INTEGER DEFAULT -1)  IS
   cursor kaikkirenkaat IS SELECT * FROM renkaat ;
   trengas kaikkirenkaat%ROWTYPE ;
BEGIN
   
   htp.formselectopen(snimi);
   IF length(tyhja)>0 THEN
      IF valittu = -1 THEN 
	 htp.formselectoption(tyhja,'selected','value=-1');
      else
	 htp.formselectoption(tyhja,NULL ,'value=-1');
      END IF;
   END IF;
   
   FOR trengas IN kaikkirenkaat LOOP
      IF trengas.koodi = valittu THEN 
	 htp.formselectoption(trengas.valmistaja||','||trengas.tyyppi,
	   'selected','value='||trengas.koodi);
      ELSE
	 htp.formselectoption(trengas.valmistaja||','||trengas.tyyppi,
	   NULL,'value='||trengas.koodi);
      END IF;
   END LOOP;
   
   htp.formselectclose;
   
   EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri rengasselect suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON rengasselect TO www_user;
EXIT
  
