CREATE OR replace PROCEDURE tallipoista ( tkoodi IN INTEGER,
				       nappula IN VARCHAR2 DEFAULT NULL ) IS
   poistot talli%ROWTYPE;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   
   SELECT * INTO poistot FROM talli WHERE koodi=tkoodi;
   DELETE aika WHERE aika.tyyppi IN (SELECT tyyppi FROM aikasuhteet 
     WHERE ensimmainen='talli') AND ekakoodi=tkoodi;
   DELETE talli WHERE koodi=tkoodi;
   
   otsikko('Talli poistettu',true);
   htp.p(poistot.nimi||'-talli on poistettu. Voit palata ');
   htp.anchor('ops$kpalin.tallimuokk','muokkaamaan');
   htp.p(' talleja.');
   paate ;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri tallipoista suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON tallipoista TO www_user;
EXIT
  
