CREATE OR replace PROCEDURE taptyyppiselect(snimi IN VARCHAR2 ,
				       tyhja IN VARCHAR2 DEFAULT null,
				       valittu IN INTEGER DEFAULT -1)  IS
   cursor tyyp IS SELECT * FROM tapaustyyppi;
   tap tyyp%ROWTYPE ;
BEGIN
   
   htp.formselectopen(snimi);
   IF length(tyhja)>0 THEN
      IF valittu = -1 THEN 
	 htp.formselectoption(tyhja,'selected','value=-1');
      else
	 htp.formselectoption(tyhja,NULL ,'value=-1');
      END IF;
   END IF;
   
   FOR tap IN tyyp LOOP
      IF tap.tyyppi = valittu THEN 
	 htp.formselectoption(tap.kuvaus,'selected',
			     'value='||tap.tyyppi);
      ELSE
	 htp.formselectoption(tap.kuvaus,NULL,
			     'value='||tap.tyyppi);
      END IF;
   END LOOP;
   
   htp.formselectclose;
   
   EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri taptyyppiselect suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON taptyyppiselect TO www_user;
EXIT
  
