CREATE OR replace PROCEDURE uusirengas( rkoodi IN INTEGER,
					rnappi IN VARCHAR2,
					rvalmist IN VARCHAR2,
					rtyyppi IN VARCHAR2 DEFAULT NULL) 
IS
   uusikoodi INTEGER ;
BEGIN
   
   
   IF rnappi = 'Pivit' THEN
      UPDATE renkaat
	SET valmistaja=rvalmist, tyyppi=rtyyppi
	WHERE renkaat.koodi=rkoodi;
   ELSIF rnappi = 'Poista' THEN 
      DELETE renkaat WHERE koodi=rkoodi;
   ELSIF rnappi = 'Lis' THEN

      SELECT max(koodi) INTO uusikoodi FROM renkaat;
      
      IF uusikoodi  >= 0 THEN
	 uusikoodi := uusikoodi+1; --Tysin turhaa mutta NULL on outolintu
      ELSE
	 uusikoodi :=0;
      END IF;

     
      INSERT INTO renkaat VALUES (uusikoodi,rvalmist,rtyyppi);
   ELSE
      htp.p('Virhe uusirengas-proseduurissa. Ole hyv ja ota yhteytt ');
      htp.mailto('kimmo.palin@helsinki.fi','yllpitoon.');
   END IF;
     

   rengaslis;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri uusirengas suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON uusirengas TO www_user;
EXIT
  

   
