CREATE OR replace FUNCTION aikamuoto( kesto IN NUMBER) RETURN VARCHAR2
IS
   palaut VARCHAR2(64) DEFAULT NULL ;
BEGIN
   IF kesto >= 60*60 THEN
      palaut:=palaut||to_char(floor(kesto/3600))||'h';
   END IF;
   IF kesto >= 60 THEN
      palaut:= palaut||to_char(MOD(floor(kesto/60.0),60),'99')||'"';
   END IF;
   IF kesto >= 0 THEN
      palaut:=palaut||to_char(floor(mod(kesto,60)),'09')||''''||
      to_char(kesto-floor(kesto),'V999');
   END IF;
   
   RETURN palaut;
END;
/
show errors
  GRANT execute ON aikamuoto TO www_user;
EXIT
  
