CREATE OR replace PROCEDURE kisatietosyott(kuljk IN INTEGER,
					   kisak IN INTEGER)
IS
   kuski kuljettaja%ROWTYPE;
   vtulos tulos%ROWTYPE;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   
   iht2.js_checksonly;
   
   SELECT * INTO kuski FROM kuljettaja WHERE koodi=kuljk;
   
   BEGIN
      SELECT * INTO vtulos FROM tulos WHERE kuljettaja=kuljk AND kilpailu=kisak;
   EXCEPTION
      WHEN no_data_found THEN
	vtulos:=vtulos;
   END;
   
   
   otsikko(kuski.enimi||' '||kuski.snimi||':n menestys osakilpailussa.',true);
   
   htp.formopen('ops$kpalin.kisatietoasett');
   htp.formhidden('kisak',kisak);
   htp.formhidden('kuljk',kuljk);
   
   htp.tableopen(NULL,'center');
   htp.tableheader('Aika aika-ajoissa');
   htp.tableheader;
   htp.tableheader('Aika kilpailussa');
   htp.tableheader;
   htp.tablerowopen;
   htp.p('<td>');
   htp.formtext('aaaika',20,20,vtulos.aatulos,
     'onBlur="numcheck(this)"');
   htp.p('</td><td>s</td><td>');
   htp.formtext('kisaaika',20,20,vtulos.ktulos,
     'onBlur="numcheck(this)"');
   htp.p('</td><td>s</td>');
   htp.tablerowclose;
   htp.tableclose;
   
   
   htp.tableopen(NULL,'center');
   htp.tablerowopen;
   htp.p('<td colspan=50 >');
   IF vtulos.kuljettaja IS NOT NULL THEN
      htp.formsubmit('knappi','Pivit');
      htp.p('<td colspan=50>');
      htp.formsubmit('knappi','Poista');
   ELSE
      htp.formsubmit('knappi','Lis');
   END IF;
   
   htp.p('<td colspan=50>');
   htp.formreset('Peruuta','onClick=javascript:history.go(-1)');
   htp.tablerowclose;
   htp.tableclose;
   htp.formclose;


   paate ;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri kisatietosyott suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON kisatietosyott TO www_user;
EXIT
  
