CREATE OR replace PROCEDURE kotirataaseta(aikakoodi IN INTEGER,
					   krnappi IN VARCHAR2,
					   rkoodi IN INTEGER,
					   ralku IN VARCHAR2,
					   rloppu IN VARCHAR2 DEFAULT null)
IS
   taika aika%ROWTYPE;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF;
   
   
   SELECT * INTO taika FROM aika WHERE kerta=aikakoodi;
   
   IF krnappi = 'Poista' THEN
      DELETE aika WHERE kerta = taika.kerta;
      
      otsikko('Kotiratamerkint poistettu',true);
      htp.p('Merkint tallin kotiradasta on nyt poistettu.');
   ELSIF krnappi = 'Pivit' THEN
      UPDATE aika SET ekakoodi=rkoodi, 
	alkamisaika=to_date(ralku,'DD.MM.YYYY'),
	loppumisaika=to_date(rloppu,'DD.MM.YYYY')
	WHERE kerta=aikakoodi;
      
      otsikko('Tiedot pivitetty',true);
      htp.p('Tiedot tallin kotiradasta on nyt pivitetty.');
   END IF;
   
   
   htp.p(' Voit palata, joko ');
   htp.anchor('ops$kpalin.tallimuokk','tallilistaan');
   htp.p('tai ksiteltvn ');
   htp.anchor('ops$kpalin.tallisyott?tkoodi='||taika.tokakoodi,'talliin.');
    
   paate ;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri kotirataaseta suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON kotirataaseta TO www_user;
EXIT
  
