CREATE OR replace PROCEDURE laske_pisteet(kisa IN INTEGER)
IS
   cursor tulokset IS SELECT * FROM tulos WHERE kilpailu=kisa 
     ORDER BY ktulos  ;
   TYPE piste_typ IS TABLE OF INTEGER INDEX BY binary_integer;
   pist piste_typ;
   tama tulokset%ROWTYPE;
   laskuri INTEGER;
BEGIN
   pist(1):=10;
   pist(2):=6;
   pist(3):=4;
   pist(4):=3;
   pist(5):=2;
   pist(6):=1;
   laskuri:=1;
   
   FOR tama IN tulokset LOOP
     IF laskuri<7 THEN
	UPDATE tulos SET pisteet=pist(laskuri) WHERE kuljettaja=tama.kuljettaja 
	  AND kilpailu=tama.kilpailu;
     ELSE
	UPDATE tulos SET pisteet=0 WHERE kuljettaja=tama.kuljettaja 
	  AND kilpailu=tama.kilpailu;
     END IF;
     laskuri:=laskuri+1;
   END LOOP;
   
EXCEPTION
   WHEN OTHERS THEN
     close tulokset;
END;
/
show errors
  GRANT execute ON laske_pisteet TO www_user;
EXIT
      
