CREATE OR replace PROCEDURE rataselect(snimi IN VARCHAR2 ,
				       tyhja IN VARCHAR2 DEFAULT null,
				       valittu IN INTEGER DEFAULT -1)  IS
   cursor radat IS SELECT * FROM rata ;
   trata radat%ROWTYPE ;
BEGIN
   
   htp.formselectopen(snimi);
   IF length(tyhja)>0 THEN
      IF valittu = -1 THEN 
	 htp.formselectoption(tyhja,'selected','value=-1');
      else
	 htp.formselectoption(tyhja,NULL ,'value=-1');
      END IF;
   END IF;
   
   FOR trata IN radat LOOP
      IF trata.koodi = valittu THEN 
	 htp.formselectoption(trata.nimi||'('||trata.sijainti||')','selected',
			     'value='||trata.koodi);
      ELSE
	 htp.formselectoption(trata.nimi||'('||trata.sijainti||')',NULL,
			     'value='||trata.koodi);
      END IF;
   END LOOP;
   
   htp.formselectclose;
   
   EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri rataselect suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON rataselect TO www_user;
EXIT
  
