CREATE OR replace PROCEDURE ratasyott(rkoodi IN INTEGER DEFAULT null)  IS
   rtieto rata%ROWTYPE;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   otsikko('Ratatietojen muokkaus',true);
   iht2.js_checksonly;
   IF rkoodi >= 0 THEN 
      SELECT * INTO rtieto FROM rata WHERE rata.koodi=rkoodi;
   END IF;
   
   IF length(rtieto.kuvaurl) >0 THEN
      htp.p('<img src='||rtieto.kuvaurl||' alt=kuva:'||rtieto.kuvaurl||'>');
   END IF;
   
   htp.formopen('ops$kpalin.rataaseta');
   
   IF rkoodi >= 0 THEN
      htp.formhidden('rkoodi',rtieto.koodi);
   ELSE
      htp.formhidden('rkoodi',-1);
   END IF;
   
   htp.tableopen;
   htp.tablerowopen;
   htp.tabledata('Radan nimi:');
   htp.p('<td>');
   htp.formtext('rnimi',64,256,rtieto.nimi);

   htp.tablerowclose;
   htp.tablerowopen;
   htp.tabledata('Radan sijainti:');
   htp.p('<td>');
   htp.formtext('rsijainti',64,256,rtieto.sijainti);
   htp.tablerowclose;
   htp.tableclose;
   htp.line;
   
   htp.tableopen;

   htp.tablerowopen;
   htp.tabledata('Radan pituus:');
   htp.p('<td>');
   htp.formtext('rpituus',10,7,rtieto.pituus,
     'onBlur="numcheck(this)"');
   htp.p(' km');
   htp.tablerowclose;
   
   htp.tablerowopen;
   htp.tabledata('Radan kierrosenntys:');
   htp.p('<td>');
   htp.formtext('rennatys',10,10,rtieto.ennatys,
     'onBlur="numcheck(this)"');
   htp.p(' sekuntia</td>');
   htp.tablerowclose;
   
   htp.tablerowopen;
   htp.tabledata('Radan valmistumisvuosi: ');
   htp.p('<td>');
   htp.formtext('rvalvuosi',4,4,rtieto.vvuosi,
     'onBlur="numcheck(this)"');
   
   htp.tablerowclose;
   htp.tablerowopen;
   htp.tabledata('Kuva radasta (URL):');
   htp.p('<td>');
   htp.formtext('rkuva',80,256,rtieto.kuvaurl);
   htp.tableclose;
   
   htp.tableopen(NULL,'center');
   htp.tablerowopen;
   htp.p('<td colspan=50 >');
   IF rkoodi >= 0 THEN
      htp.formsubmit('rnappi','Pivit');
      htp.p('<td colspan=50>');
      htp.formsubmit('rnappi','Poista');
   ELSE
      htp.formsubmit('rnappi','Lis');
   END IF;
   
   htp.p('<td colspan=50>');
   htp.formreset('Peruuta', 'onClick=javascript:history.go(-1)');
   htp.tablerowclose;
   htp.tableclose;
   htp.formclose;
   
   paate ;

EXCEPTION
   WHEN no_data_found THEN
     htp.p('Hakemaasi rataa ei en lydy tietokannasta. Se on joko ');
     htp.p('poistettu tai olet saanut jostain vanhentuneen linkin.');
     htp.para ;
     htp.p('Tll hetkell kannassa olevat kilparadat lydt ');
     htp.anchor('ops$kpalin.radatmuokk','ratojenksittelyn');
     htp.p(' psivulta');
     paate;
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri ratasyott suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON ratasyott TO www_user;
EXIT
  
