CREATE OR replace PROCEDURE rengasvalinta(aikakoodi IN INTEGER)
IS
   taika aika%ROWTYPE;
   tallinimi VARCHAR2(128);
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF;
   
   SELECT * INTO taika FROM aika WHERE kerta=aikakoodi;
   SELECT nimi INTO tallinimi FROM talli WHERE koodi=taika.tokakoodi;

   iht2.js_checksonly;
   otsikko(tallinimi||'-tallin kyttm rengastyyppi',true);
   htp.para;
   
   
   htp.formopen('ops$kpalin.rengasaseta');
   htp.formhidden('aikakoodi',aikakoodi);
   
   htp.tableopen(NULL,'center');
   htp.tableheader('Renkaat');
   htp.tableheader('Alkaen');
   htp.tableheader('Asti');
   htp.tablerowopen;
   htp.p('<td>');
   rengasselect('rkoodi',NULL,taika.ekakoodi);
   htp.p('</td><td>');
   htp.formtext('ralku',13,13,to_char(taika.alkamisaika,'DD.MM.YYYY'),
	       'onBlur="datecheck(this)"');
   htp.p('</td><td>');
   htp.formtext('rloppu',13,13,to_char(taika.loppumisaika,'DD.MM.YYYY'),
	       'onBlur="datecheck(this)"');
   htp.p('</td>');
   htp.tablerowclose;
   htp.tableclose;

   htp.para;
   
   htp.tableopen(NULL,'center');
   htp.tablerowopen;
   htp.p('<td colspan=50>');
   htp.formsubmit('rnappi','Pivit');
   htp.p('<td colspan=50>');
   htp.formsubmit('rnappi','Poista');
   htp.p('<td colspan=50>');
   htp.formreset('Peruuta','onClick=javascript:history.go(-1)');
   htp.tableclose;
   htp.formclose;
   paate ;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri rengasvalinta suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON rengasvalinta TO www_user;
EXIT
  
