CREATE OR replace PROCEDURE tallimuokk  IS
   cursor kaikkitallit IS SELECT * FROM talli;
   tamat talli%ROWTYPE;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   otsikko('Tallien ksittely',true);
   
   htp.p('Jrjestelmss on tallennetuna seuraavat tallit:');
   htp.ulistopen;
   
   FOR tamat IN kaikkitallit LOOP
      htp.listitem('<a href=ops$kpalin.tallisyott?tkoodi='||tamat.koodi ||'>'||
	tamat.nimi||'</a> ('||tamat.kotipaikka||').');
   END LOOP;
   
   htp.listitem('<a href=ops$kpalin.tallisyott>Lis uusi talli.</a>');
   htp.ulistclose;
   
   htp.p('Valitse listasta talli jota haluat muokata. Kun olet tyytyvinen, ');
   htp.p('voit palata ');
   htp.anchor('ops$kpalin.paasivu','psivulle.');
   paate ;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri tallimuokk suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON tallimuokk TO www_user;
EXIT
  
