CREATE OR replace PROCEDURE talliselect(snimi IN VARCHAR2 ,
				       tyhja IN VARCHAR2 DEFAULT null,
				       valittu IN INTEGER DEFAULT -1)  IS
   cursor kaikkitallit IS SELECT koodi,nimi FROM talli ;
   ttalli kaikkitallit%ROWTYPE ;
BEGIN
   
   htp.formselectopen(snimi);
   IF length(tyhja)>0 THEN
      IF valittu = -1 THEN 
	 htp.formselectoption(tyhja,'selected','value=-1');
      else
	 htp.formselectoption(tyhja,NULL ,'value=-1');
      END IF;
   END IF;
   
   FOR ttalli IN kaikkitallit LOOP
      IF ttalli.koodi = valittu THEN 
	 htp.formselectoption(ttalli.nimi,'selected',
			     'value='||ttalli.koodi);
      ELSE
	 htp.formselectoption(ttalli.nimi,NULL,
			     'value='||ttalli.koodi);
      END IF;
   END LOOP;
   
   htp.formselectclose;
   
   EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri tallitselect suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON talliselect TO www_user;
EXIT
  
