CREATE OR replace PROCEDURE tallisuhdevalinta(aikakoodi IN INTEGER)
IS
   taika aika%ROWTYPE;
   ttalli talli%ROWTYPE;
   kuski kuljettaja%ROWTYPE;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF;
   
   SELECT * INTO taika FROM aika WHERE kerta=aikakoodi;
   SELECT * INTO ttalli FROM talli WHERE koodi=taika.tokakoodi;
   SELECT * INTO kuski FROM kuljettaja WHERE koodi=taika.ekakoodi;

   
   otsikko(kuski.enimi||' '||kuski.snimi||':n tallikiinnitys',true);
   htp.para;
   
   
   htp.formopen('ops$kpalin.tallisuhdeaseta');
   htp.formhidden('aikakoodi',aikakoodi);
   htp.tableopen(NULL,'center');
   htp.tableheader('Talli');
   htp.tableheader('Alkaen');
   htp.tableheader('Asti');
   htp.tablerowopen;
   htp.p('<td>');
   talliselect('tkoodi',NULL,ttalli.koodi);
   htp.p('</td><td>');
   htp.formtext('talku',13,13,to_char(taika.alkamisaika,'DD.MM.YYYY'),
     'onBlur="datecheck(this)"');
   htp.p('</td><td>');
   htp.formtext('tloppu',13,13,to_char(taika.loppumisaika,'DD.MM.YYYY'),
     'onBlur="datecheck(this)"');
   htp.p('</td>');
   htp.tablerowclose;
   htp.tableclose;

   htp.para;
   
   htp.tableopen(NULL,'center');
   htp.tablerowopen;
   htp.p('<td colspan=50>');
   htp.formsubmit('tnappi','Pivit');
   htp.p('<td colspan=50>');
   htp.formsubmit('tnappi','Poista');
   htp.p('<td colspan=50>');
   htp.formreset('Peruuta','onClick=javascript:history.go(-1)');
   htp.tableclose;
   htp.formclose;
   paate ;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri tallisuhdevalinta suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON tallisuhdevalinta TO www_user;
EXIT
  
