CREATE OR replace PROCEDURE taptyypaset(tkuvaus IN VARCHAR2 DEFAULT NULL, 
					tkoodi IN INTEGER,
					tnappi IN VARCHAR2)  IS
   kasitkoodi INTEGER;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   
   IF tkoodi>=0 THEN
      kasitkoodi:=tkoodi;
   ELSE
      SELECT max(tyyppi)+1 INTO kasitkoodi FROM tapaustyyppi;
      IF kasitkoodi IS NULL THEN
	 kasitkoodi:=0;
      END IF;
   END IF;
   
   IF tnappi = 'Poista' THEN
      DELETE tapaustyyppi WHERE tyyppi=kasitkoodi;
   ELSIF tnappi='Pivit' THEN
      UPDATE tapaustyyppi SET kuvaus=tkuvaus WHERE tyyppi=kasitkoodi;
   ELSIF tnappi = 'Lis' THEN
      INSERT INTO tapaustyyppi VALUES (kasitkoodi,tkuvaus);
   END IF;
   
   taptyypsyott;
         

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri taptyypaset suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON taptyypaset TO www_user;
EXIT
  
