CREATE OR replace PROCEDURE taptyypsyott(tkoodi IN INTEGER DEFAULT NULL)  IS
   cursor kaikkitapaukset IS SELECT * FROM tapaustyyppi;
   tamat kaikkitapaukset%ROWTYPE;
   kastapaus tapaustyyppi%ROWTYPE;
   uusikoodi INTEGER;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   otsikko('Tapahtumatyypit',true);
   
   
   BEGIN
--      SELECT max(tyyppi)+1 INTO uusikoodi FROM tapaustyyppi;
      SELECT * INTO kastapaus FROM tapaustyyppi WHERE tyyppi=tkoodi;
   EXCEPTION
      WHEN OTHERS THEN
	uusikoodi:=0;
   END;
   
   htp.p('Tallennetut tapaustyypit:');
   htp.ulistopen;
   
   FOR tamat IN kaikkitapaukset LOOP
      htp.listitem('<a href=ops$kpalin.taptyypsyott?tkoodi='||tamat.tyyppi||
	'>'||tamat.kuvaus||'</a>');
   END LOOP;
   htp.ulistclose;
   
   htp.formopen('ops$kpalin.taptyypaset');
   IF kastapaus.tyyppi IS NULL THEN 
      htp.formhidden('tkoodi',-1);
   ELSE
      htp.formhidden('tkoodi',kastapaus.tyyppi);
   END IF;
   
   htp.tableopen;
   htp.tabledata('Tapahtuman kuvaus');
   htp.p('<td>');
   htp.formtext('tkuvaus',64,512,kastapaus.kuvaus);
   htp.tableclose;
   
   htp.tableopen(NULL,'center');
   htp.tablerowopen;
   htp.p('<td colspan=50 >');
   IF tkoodi >= 0 THEN
      htp.formsubmit('tnappi','Pivit');
      htp.p('<td colspan=50>');
      htp.formsubmit('tnappi','Poista');
   ELSE
      htp.formsubmit('tnappi','Lis');
   END IF;
   
   htp.p('<td colspan=50>');
   htp.formreset('Peruuta','onClick=javascript:history.go(-1)');
   htp.tablerowclose;
   htp.tableclose;
   htp.formclose;

   
   
   paate ;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri taptyypsyott suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON taptyypsyott TO www_user;
EXIT
  


