CREATE OR replace PROCEDURE uusimoottori( mkoodi IN INTEGER,
					  mnappi IN VARCHAR2,
					  mvalmist IN VARCHAR2,
					  mvmalli IN VARCHAR2 DEFAULT NULL,
					  mtyyppi IN VARCHAR2 DEFAULT NULL,
					  mteho IN INTEGER DEFAULT NULL)
IS
   uusikoodi INTEGER ;
BEGIN
   
   
   IF mnappi = 'Pivit' THEN
      UPDATE moottori
	SET valmistaja=mvalmist, tyyppi=mtyyppi,
	vuosimalli=to_date(mvmalli,'YYYY'),teho=mteho
	WHERE koodi=mkoodi;
   ELSIF mnappi = 'Poista' THEN 
      DELETE moottori WHERE koodi=mkoodi;
   ELSIF mnappi = 'Lis' THEN

      SELECT max(koodi) INTO uusikoodi FROM moottori;
      
      IF uusikoodi  >= 0 THEN
	 uusikoodi := uusikoodi+1; --Tysin turhaa mutta NULL on outolintu
      ELSE
	 uusikoodi :=0;
      END IF;

     
      INSERT INTO moottori VALUES (uusikoodi,mtyyppi,to_date(mvmalli,'YYYY'),
				  mteho,mvalmist);
   ELSE
      htp.p('Virhe uusimoottori-proseduurissa. Ole hyv ja ota yhteytt ');
      htp.mailto('kimmo.palin@helsinki.fi','yllpitoon.');
   END IF;
     

   moottorilis;

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri uusimoottori suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON uusimoottori TO www_user;
EXIT
  

   

