CREATE OR replace PROCEDURE valitsekaudet(tkausi IN INTEGER,
					 valitse IN VARCHAR2)  IS
   cursor seuraavat IS SELECT k.koodi, rata.nimi AS nimi, k.kilpailu 
     FROM kilpailu k ,rata
     WHERE k.sarja=tkausi
     AND k.rata=rata.koodi
     AND k.kilpailu>(SYSDATE-1)
     ORDER BY kilpailu;
   cursor menneet IS SELECT k.koodi, rata.nimi AS nimi, k.kilpailu 
     FROM kilpailu k  ,rata
     WHERE k.sarja=tkausi 
     AND k.rata=rata.koodi
     AND (k.kilpailu<=(SYSDATE-1) OR k.kilpailu IS NULL)
     ORDER BY kilpailu;
   tamasarja sarja%ROWTYPE;
   kisa seuraavat%ROWTYPE;
BEGIN
   IF NOT autentikoi THEN 
      RETURN  ;
   END IF; 
   
   
   IF tkausi = -1 THEN
      sarjasyott(tkausi);
   ELSE
      SELECT * INTO tamasarja FROM sarja WHERE koodi=tkausi;
      otsikko('Sarja '||tamasarja.vuosi,true);
      
      htp.p('Sarjan seuraavat osakilpailut:');
      htp.ulistopen;
      FOR kisa IN seuraavat LOOP
	 htp.listitem('<a href=ops$kpalin.kilpailusyott?kkoodi='||kisa.koodi||
	   '>'||kisa.nimi||' '||to_char(kisa.kilpailu,'DD.MM.YYYY')||'</a>');
      END LOOP;
      htp.ulistclose;
      htp.p('Sarjan ajetut osakilpailut:');
      htp.ulistopen;
      FOR kisa IN menneet LOOP
	 htp.listitem('<a href=ops$kpalin.kilpailusyott?kkoodi='||kisa.koodi||
	   '>'||kisa.nimi||' '||to_char(kisa.kilpailu,'DD.MM.YYYY')||'</a>');
      END LOOP;
      htp.ulistclose;
      htp.p('Uusia kilpailuja ja talleja sarjaan saa listty ');
      htp.anchor('ops$kpalin.sarjasyott?tkausi='||tkausi,'tlt');
      htp.p('. Takaisin psivulle psee ');
      htp.anchor('ops$kpalin.paasivu','tt kautta');
      htp.p('.');
      
      paate ;
   END IF;
   

EXCEPTION
   WHEN OTHERS THEN
     htp.p('<h3>Proseduuri valitsekaudet suoritus pttyi virheeseen:</h3>');
     htp.p('<font color=red>'|| sqlerrm || '</font>');
END;
/
show errors
  GRANT execute ON valitsekaudet TO www_user;
EXIT
  
